/*
 * beam.h
 * mume protocol related stuff
 */

#define MCIDENT "~$#EI\n"	/* MUME client identificator */
#define MCIDENTLEN  6

#define MPI "~$#E"		/* MUME protocol introducer */
#define MPILEN	4
#define IS_MPI(p, l) \
  (l >= 4 && (p)[0] == '~' && (p)[1] == '$' && (p)[2] == '#' && (p)[3] == 'E')

#define MAXDESCLEN 80		/* session description lenght */

/* editing session control */
typedef struct editsess {
    struct editsess *next;
    int num;	/* session number */
    int state;	/* phase of receiving */
    int mode;	/* View/Edit/Cancelled */
    unsigned long
	key;	/* message identificator */
    long pos;	/* bytes received */
    long size;	/* message size/temp file size */
    long time;	/* temp file mtime */
    int pid;	/* child pid */
    int fd;	/* temp file fd */
    char *fname;/* temp file name */
    char desc[MAXDESCLEN];
} editsess;

int mp_receive();
void cancel_edit();
int attend_child();

extern char *edit_start, *edit_end;
extern editsess *edit_sess;

