/*
 * ctypes.h
 */

#if defined(HC_ASCII) || defined(HC_ISO_LATIN1)
extern const unsigned char c_type[256], c_toupper[256], c_tolower[256];
#define init_ctype()	/* nop */
#else
extern unsigned char c_type[256], c_toupper[256], c_tolower[256];
void init_ctype();
#endif

#define digit_value(c) ((c) - '0')	/* ugh */
#define i_to_digit(i) ('0' + i)

#undef toupper
#undef tolower
#define toupper(c) c_toupper[(unsigned char)(c)]
#define tolower(c) c_tolower[(unsigned char)(c)]

#undef isprint
#undef isgraph
#undef isdigit
#define C_ISTYPE(c, flag) ((c_type[(unsigned char)c] & flag) != 0)
#define isprint(c)   C_ISTYPE((c), 0x01)
#define isgraph(c)   C_ISTYPE((c), 0x02)
#define islabel(c)   C_ISTYPE((c), 0x0c)
#define isword(c)    C_ISTYPE((c), 0x0c)
#define isdigit(c)   C_ISTYPE((c), 0x08)
#define islparen(c)  C_ISTYPE((c), 0x10)
#define isrparen(c)  C_ISTYPE((c), 0x20)
#define iswalkdir(c) C_ISTYPE((c), 0x40)
#define iswalkseq(c) C_ISTYPE((c), 0x48)

#define LRPARENS(a, b)					\
	(((char)(a) == '(' && (char)(b) == ')') ||	\
	 ((char)(a) == '[' && (char)(b) == ']') ||	\
	 ((char)(a) == '{' && (char)(b) == '}'))

